---
title: Intl.ListFormat.prototype.formatToParts()
slug: Web/JavaScript/Reference/Global_Objects/Intl/ListFormat/formatToParts
tags:
  - Internationalization
  - Intl
  - JavaScript
  - ListFormat
  - Method
  - Prototype
---
<div>{{JSRef}}</div>

<p>The <strong><code>Intl.ListFormat.prototype.formatToParts()</code></strong> method returns an {{jsxref("Array")}} of objects representing the different components that can be used to format a list of values in a locale-aware fashion.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Intl.ListFormat.prototype.formatToParts(<var>list</var>)
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>list</code></dt>
 <dd>An {{jsxref("Array")}} of values to be formatted according to a locale.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{jsxref("Array")}} of components which contains the formatted parts from the list.</p>

<h2 id="Description">Description</h2>

<p>Whereas {{jsxref("ListFormat.prototype.format()", "Intl.ListFormat.prototype.format()")}} returns a string being the formated version of the list (according to the given locale and style options), <code>formatToParts()</code> returns an array of the different components of the formated string.</p>

<p>Each element of the resulting array has two properties: <code>type</code> and <code>value</code>. The <code>type</code> property may be either <code>"element"</code>, which refers to a value from the list, or <code>"literal"</code> which refers to a linguistic construct. The <code>value</code> property gives the content, as a string, of the token.</p>

<p>The locale and style options used for formatting are given when constructing the {{jsxref("ListFormat", "Intl.ListFormat")}} instance.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_formatToParts">Using formatToParts</h3>

<pre class="brush: js">const fruits = ['Apple', 'Orange', 'Pineapple'];
const myListFormat = new Intl.ListFormat('en-GB', { style: 'long', type: 'conjunction' });

console.table(myListFormat.formatToParts(fruits));
// [
//  { "type": "element", "value": "Apple" },
//  { "type": "literal", "value": ", " },
//  { "type": "element", "value": "Orange" },
//  { "type": "literal", "value": ", and " },
//  { "type": "element", "value": "Pineapple" }
// ]
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Intl.ListFormat', '#sec-Intl.ListFormat.prototype.formatToParts', 'formatToParts()')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Intl.ListFormat.formatToParts")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("ListFormat", "Intl.ListFormat")}}</li>
 <li>{{jsxref("ListFormat.prototype.format()", "Intl.ListFormat.prototype.format()")}}</li>
 <li>{{jsxref("RelativeTimeFormat.formatToParts()", "Intl.RelativeTimeFormat.prototype.formatToParts()")}}</li>
 <li>{{jsxref("NumberFormat.formatToParts()", "Intl.NumberFormat.prototype.formatToParts()")}}</li>
 <li>{{jsxref("DateTimeFormat.formatToParts()", "Intl.DateTimeFormat.prototype.formatToParts()")}}</li>
</ul>
